/* ******************************************************************************

     XMLStudio - Editor integrato per documenti XML
     Programma per la Tesi di Laurea di Paolo Guagliumi - pguagliumi@libero.it
     Docente relatore: Prof.ssa Paola Giannini - giannini@di.unito.it

     AboutBox.java - Definizione classe per l'implementazione dell'AboutBox
    (C) 2002 Paolo Guagliumi - Il programma adotta la licenza GPL allegata

   ****************************************************************************** */


// **** importa i packages utili ****

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;

import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;


// **** definizione classe per definire l'AboutBox ****

class AboutBox extends JDialog implements ActionListener, WindowListener
{
	// costruttore della classe

	public AboutBox(JFrame parent)
  	{
		super(parent, "Informazioni sul programma", true); // richiama la superclasse per creare la JDialog relativa all'AboutBox

		JPanel pannello1, pannello2, pannello3;

    		JLabel label1 = new JLabel(new ImageIcon("./Risorse/icona.gif")); // aggiunge l'immagine alla label
    		Border b1 = new BevelBorder(BevelBorder.LOWERED); // definisce un bordo smussato
    		Border b2 = new EmptyBorder(5, 5, 5, 5); // definisce un bordo vuoto con le dimensioni specificate, alto, sinistra, basso, destra
    		label1.setBorder(new CompoundBorder(b1, b2)); // definizione di un bordo nella label composto da due bordi in uno singolo
    		pannello1 = new JPanel(); // definisce un pannello e vi aggiunge la label
    		pannello1.add(label1);

    		String messaggio = "XMLStudio - Versione 1.0\n" + "Editor integrato per documenti XML";
    		JTextArea areaTxt = new JTextArea(messaggio); // crea una JTextArea e vi aggiunge il messaggio
    		areaTxt.setBorder(new EmptyBorder(5, 10, 5, 10)); // imposta nell'area testuale un bordo empty
    		areaTxt.setFont(new Font("Helvetica", Font.BOLD, 12)); // imposta il carattere per l'area di testo
    		areaTxt.setEditable(false); // quest'area di testo non e' editabile
    		areaTxt.setBackground(getBackground()); // imposta il background dell'area di testo come il background attuale della JDialog
		pannello2 = new JPanel();
    		pannello2.setLayout(new BoxLayout(pannello2, BoxLayout.Y_AXIS)); // dispone il pannello2 secondo questo layout verticale
    		pannello2.add(areaTxt); // aggiunge al pannello2 la prima frase

    		messaggio = "Programma per la Tesi di Laurea di Paolo Guagliumi - pguagliumi@libero.it\n\nDocente relatore: Prof.ssa Paola Giannini - giannini@di.unito.it\n\n(C) 2002 Paolo Guagliumi - Il programma adotta la licenza GPL allegata";
    		JTextArea areaTxt2 = new JTextArea(messaggio); // crea una JTextArea e vi aggiunge il messaggio
    		areaTxt2.setBorder(new EmptyBorder(5, 10, 5, 10)); // imposta nell'area testuale un bordo empty
    		areaTxt2.setFont(new Font("Arial", Font.PLAIN, 12)); // imposta il carattere per l'area di testo
    		areaTxt2.setEditable(false); // quest'area di testo non e' editabile
    		areaTxt2.setBackground(getBackground()); // imposta il background dell'area di testo come il background attuale della JDialog
    		pannello2.add(areaTxt2); // aggiunge al pannello2 la seconda frase

    		JButton bottoneOK = new JButton("OK"); // crea un bottone "OK"
    		bottoneOK.addActionListener(this);
    		pannello3 = new JPanel(); // aggiunge il bottone "OK" ad un nuovo pannello3
    		pannello3.add(bottoneOK);

    		getContentPane().add(pannello1, BorderLayout.WEST); // aggiunge il pannello contenente l'immagine alla finestra
	     getContentPane().add(pannello2, BorderLayout.CENTER); // aggiunge il pannello contenente le due frasi al centro della finestra
    		getContentPane().add(pannello3, BorderLayout.SOUTH); // aggiunge il pannello contenente il bottone OK nella parte bassa della finestra

    		pack(); // causa alla finestra di essere ridimensionata secondo la dimensione dei suoi sottocomponenti
    		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize(); // calcola le dimensioni dello schermo
		setLocation((screenSize.width - getWidth()) / 2, (screenSize.height - getHeight()) / 2); // sposta la JDialog nella posizione centrale
		setVisible(true); // la JDialog  visibile
    		setResizable(false); // non  possibile modificare la dimensione della JDialog
    		addWindowListener(this);
  	}

  	// **** metodi invocati quando avviene un action event ****

  	public void actionPerformed(ActionEvent e)
	{
		String evento = e.getActionCommand();

		if (evento.equals("OK"))
		{
			setVisible(false);
			dispose();
		}

    	}

    	// **** il metodo windowClosing gestisce la chiusura della finestra ****

	public void windowClosing(WindowEvent event)
	{
		setVisible(false);
		dispose();
	}

    // **** sette metodi relativi alla finestra dell'editor, implementabili se necessario ****

	public void windowIconified(WindowEvent event)
	{
	}

	public void windowDeiconified(WindowEvent event)
	{
	}

	public void windowClosed(WindowEvent event)
	{
	}

	public void windowDeactivated(WindowEvent event)
	{
	}

	public void windowActivated(WindowEvent event)
	{
	}

	public void windowOpened(WindowEvent event)
	{
	}
}