/* ******************************************************************************

     XMLStudio - Editor integrato per documenti XML
     Programma per la Tesi di Laurea di Paolo Guagliumi - pguagliumi@libero.it
     Docente relatore: Prof.ssa Paola Giannini - giannini@di.unito.it

     CopiaCorretta.java - Definizione classe per la rimozione delle linee tab
    (C) 2002 Paolo Guagliumi - Il programma adotta la licenza GPL allegata

   ****************************************************************************** */


// **** importa i packages utili ****

import java.io.*;
import java.util.regex.*;


// **** classe per la scrittura del file xml privato delle linee vuote (nel file dei tag xml) contenenti solo caratteri tab, \t, \n ****

class CopiaCorretta
{
	// costruttore della classe

	public CopiaCorretta(File origineFile)
	{
		String linea; // definisce una singola linea da analizzare
		int c; // definisce un singolo carattere per la lettura del file carattere per carattere

		try
		{
	        	BufferedReader in = new BufferedReader(new FileReader(origineFile));
	        	BufferedWriter out = new BufferedWriter(new FileWriter("./Tag/TagXmlBackup.xml")); // file di backup del corrente file di tag xml

		     while ((linea = in.readLine()) != null) // preleva una linea dal file di origine e controlla che non sia nulla
		     {
			     if (LineaNonVuota(linea)) // solo se la linea ha dei caratteri che non sono solo di tabulazione o di invio allora
			     {
				     out.write(linea, 0, linea.length()); // scrivi la linea su file
					out.newLine(); // scrivi una nuova linea
		     	}
		     }

	        	in.close(); // chiude gli stream, ha realizzato il backup di origineFile privato di caratteri \t e \n
	        	out.close();

	        	in = new BufferedReader(new FileReader("./Tag/TagXmlBackup.xml"));
	        	out = new BufferedWriter(new FileWriter(origineFile)); // file da riscrivere ora senza linee \t e \n

        		while ((c = in.read()) != -1)
           		out.write(c);

	        	in.close(); // ora origineFile e' stato riscritto senza caratteri \t e \n
	        	out.close();
        	}
        	catch (Exception e)
        	{
	        	JOptionPaneEsteso mostraEccezione = new JOptionPaneEsteso(null, "Informazione", "Eccezione rilevata nel salvataggio del nuovo documento tag (.xml): " + e);
	     }
    	}


    	// **** controlla se lineaInput contiene anche dei caratteri oppure solo i \t (e quindi i \n) ****

    	private boolean LineaNonVuota(String lineaInput)
    	{
		Pattern p = Pattern.compile(".*[a-zA-Z]+.*"); // individua qualsiasi carattere seguito da almeno 1 occorrenza di una lettera, seguita da qualsiasi carattere
		Matcher m = p.matcher(lineaInput);
		boolean b = m.matches(); // in b vi e' l'informazione se lineaInput e' conforme al pattern definito nell'espressione regolare

// 		if (b == true)
// 			System.out.println(lineaInput + "#true");
// 		else
// 			System.out.println(lineaInput + "#false");

		return b;
	}
}

