/* ******************************************************************************

     XMLStudio - Editor integrato per documenti XML
     Programma per la Tesi di Laurea di Paolo Guagliumi - pguagliumi@libero.it
     Docente relatore: Prof.ssa Paola Giannini - giannini@di.unito.it

     CreaDialog.java - Definizione classe per la creazione di una finestra Dialog
    (C) 2002 Paolo Guagliumi - Il programma adotta la licenza GPL allegata

   ****************************************************************************** */


// **** importa i packages utili ****

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;


// **** definizione classe per creare finestra Dialog ****

// Una Dialog e' una finestra top-level con un titolo e un bordo, tipicamente usata per acquisire input dall'utente

class CreaDialog extends Dialog implements ActionListener, WindowListener
{

	// componenti utilizzati per le finestre dialog

	JTextField jtesto1, jtesto2, jtesto3, jtesto4; // componente per l'editing di una singola linea di testo

	JButton pulsanteUno, pulsanteDue, pulsanteTre, cancel;

	// restituisce i seguenti valori

	static String input, input2, input3, input4;

	// esempio CreaDialog cd = new CreaDialog(this, "Vai alla linea numero", true, "1 - " + areaTesto.getLineCount(), "Vai"); // crea una finestra Dialog

	public CreaDialog(Frame parent, String titolo, boolean tipo, String intervallo, String NomePulsante)
	{
		super(parent, titolo, tipo);

		jtesto1= new JTextField(18); // crea un campo testuale per l'editing di una singola linea lungo 18 caratteri
		pulsanteUno = new JButton(NomePulsante); // crea un nuovo pulsante
		pulsanteUno.addActionListener(this); // aggiunge al pulsante la possibilit di rilevare eventi
		JLabel jlabel = new JLabel(intervallo); // crea una nuova JLabel con "intervallo" come testo
		JPanel pannello = new JPanel(); // crea un nuovo pannello contenitore
		pannello.add(jlabel); // aggiunge la jlabel al pannello
		pannello.add(jtesto1); // aggiunge il campo testuale al pannello
		pannello.add(pulsanteUno); // aggiunge il pulsante al pannello
		add(pannello); // aggiunge il pannello
		pack(); // causa alla Dialog di essere ridimensionata secondaLabelo il layout e la dimensione dei suoi sottocomponenti

		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize(); // calcola le dimensioni dello schermo
		setLocation((screenSize.width - getWidth()) / 2, (screenSize.height - getHeight()) / 2); // posiziona al centro dello schermo
		addWindowListener(this);  // per la gestione dell'evento WindowClosing della finestra dell'editor
		setVisible(true); // mostra la Dialog
	}

	// esempio CreaDialog cd = new CreaDialog(this, "Sostituisci", true, "Trova", "Sostituisci", "Ok", "Annulla");

	public CreaDialog(Frame parent, String titolo, boolean tipo, String s1, String s2, String pulsanteOk, String pulsanteAnnulla)
	{
		super(parent, titolo, tipo);

		JLabel primaLabel = new JLabel(s1);
		JLabel secondaLabel = new JLabel(s2);

		jtesto1 = new JTextField(8); // crea un campo testuale per l'editing di una singola linea lungo 8 caratteri
		jtesto2 = new JTextField(8);

		pulsanteTre = new JButton(pulsanteOk); // crea due pulsanti
		cancel = new JButton(pulsanteAnnulla);
		pulsanteTre.addActionListener(this);
		cancel.addActionListener(this);

		JPanel pannello = new JPanel(); // aggiunge a pannello primaLabel
		pannello.add(primaLabel);
		pannello.add(jtesto1);

		JPanel pannello2 = new JPanel(); // aggiunge a pannello2 secondaLabel
		pannello2.add(secondaLabel);
		pannello2.add(jtesto2);

		JPanel pannello3 = new JPanel(); // aggiunge a pannello4 i due pulsanti
		pannello3.add(pulsanteTre);
		pannello3.add(cancel);

		setLayout(new GridLayout(3,1,2,2)); // imposta il GridLayout ed aggiunge i quattro pannelli
		add(pannello);
		add(pannello2);
		add(pannello3);

		pack(); // causa alla Dialog di essere ridimensionata secondaLabelo il layout e la dimensione dei suoi sottocomponenti
		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize(); // calcola le dimensioni dello schermo
		setLocation((screenSize.width - getWidth()) / 2, (screenSize.height - getHeight()) / 2); // posiziona al centro dello schermo

		addWindowListener(this);  // per la gestione dell'evento WindowClosing della finestra dell'editor
		setVisible(true); // mostra la Dialog
	}

	// esempio CreaDialog cd = new CreaDialog(this, "Imposta la dimensione finestra", true, "X (800)", "Y (600)", "Pannello orizzontale (400)", "Pannello verticale (640)", "Ok", "Annulla");

	public CreaDialog(Frame parent, String titolo, boolean tipo, String s1, String s2, String s3, String s4, String pulsanteOk, String pulsanteAnnulla)
	{
		super(parent, titolo, tipo);

		JLabel primaLabel = new JLabel(s1);
		JLabel secondaLabel = new JLabel(s2);
		JLabel terzaLabel = new JLabel(s3);
		JLabel quartaLabel = new JLabel(s4);

		jtesto1 = new JTextField(8); // crea un campo testuale per l'editing di una singola linea lungo 8 caratteri
		jtesto2 = new JTextField(8);
		jtesto3 = new JTextField(4);
		jtesto4 = new JTextField(4);

		pulsanteDue = new JButton(pulsanteOk); // crea due pulsanti
		cancel = new JButton(pulsanteAnnulla);
		pulsanteDue.addActionListener(this);
		cancel.addActionListener(this);

		JPanel pannello = new JPanel(); // aggiunge a pannello primaLabel
		pannello.add(primaLabel);
		pannello.add(jtesto1);

		JPanel pannello2 = new JPanel(); // aggiunge a pannello2 secondaLabel
		pannello2.add(secondaLabel);
		pannello2.add(jtesto2);

		JPanel pannello3 = new JPanel(); // aggiunge a pannello3 terzaLabel
		pannello3.add(terzaLabel);
		pannello3.add(jtesto3);

		JPanel pannello4 = new JPanel(); // aggiunge a pannello3 quartaLabel
		pannello4.add(quartaLabel);
		pannello4.add(jtesto4);

		JPanel pannello5 = new JPanel(); // aggiunge a pannello4 i due pulsanti
		pannello5.add(pulsanteDue);
		pannello5.add(cancel);

		setLayout(new GridLayout(5,1,2,2)); // imposta il GridLayout ed aggiunge i quattro pannelli
		add(pannello);
		add(pannello2);
		add(pannello3);
		add(pannello4);
		add(pannello5);

		pack(); // causa alla Dialog di essere ridimensionata secondaLabelo il layout e la dimensione dei suoi sottocomponenti
		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize(); // calcola le dimensioni dello schermo
		setLocation((screenSize.width - getWidth()) / 2, (screenSize.height - getHeight()) / 2); // posiziona al centro dello schermo

		addWindowListener(this);  // per la gestione dell'evento WindowClosing della finestra dell'editor
		setVisible(true); // mostra la Dialog
	}

	// risponde ad azioni dell'utente ed esegue del codice: in attesa di eventi dai pulsanti

	public void actionPerformed(ActionEvent e)
	{

		String event = e.getActionCommand();

		if (e.getSource() == pulsanteUno) // e' stata rilevata la pressione del pulsanteUno
		{
			input = jtesto1.getText().trim(); // preleva il testo e rimuove gli spazi bianchi
			if(input.length() == 0)
				input = null;
			dispose(); // chiude la finestra Dialog
		}
		else
			if (e.getSource() == pulsanteTre) // e' stata rilevata la pressione del pulsanteDue
			{
				input = jtesto1.getText().trim(); // preleva il testo e rimuove gli spazi bianchi
				input2 = jtesto2.getText().trim();

				if(input.length() == 0)
					input = null;
        			if(input2.length() == 0)
					input2 = null;

				dispose(); // chiude la finestra Dialog
			}
			else
				if (e.getSource() == pulsanteDue) // e' stata rilevata la pressione del pulsanteDue
				{
					input = jtesto1.getText().trim(); // preleva il testo e rimuove gli spazi bianchi
					input2 = jtesto2.getText().trim();
					input3 = jtesto3.getText().trim();
					input4 = jtesto4.getText().trim();

					if(input.length() == 0)
						input = null;
        				if(input2.length() == 0)
						input2 = null;
					if(input3.length() == 0)
						input3 = null;
					if(input4.length() == 0)
						input4 = null;

					dispose(); // chiude la finestra Dialog
				}
				else
					if (e.getSource() == cancel) // e' stata rilevata la pressione del pulsante Cancel
					{
						dispose(); // chiude la finestra Dialog
					}
	}

	// il metodo getString restituisce l'input inserito dall'utente nel primo campo

	public static String getString()
	{
		return input;
	}

	// il metodo getString2 restituisce l'input inserito dall'utente nel secondo campo

	public static String getString2()
	{
		return input2;
	}

	// il metodo getString3 restituisce l'input inserito dall'utente nel terzo campo

	public static String getString3()
	{
		return input3;
	}

	// il metodo getString4 restituisce l'input inserito dall'utente nel quarto campo

	public static String getString4()
	{
		return input4;
	}

	// **** il metodo windowClosing gestisce la chiusura della finestra ****

	public void windowClosing(WindowEvent event)
	{
		dispose(); // chiude la finestra Dialog
	}

     // **** sette metodi relativi alla finestra Dialog, implementabili se necessario ****

	public void windowIconified(WindowEvent event)
	{
	}

	public void windowDeiconified(WindowEvent event)
	{
	}

	public void windowClosed(WindowEvent event)
	{
	}

	public void windowDeactivated(WindowEvent event)
	{
	}

	public void windowActivated(WindowEvent event)
	{
	}

	public void windowOpened(WindowEvent event)
	{
	}
}
