/* ******************************************************************************

     XMLStudio - Editor integrato per documenti XML
     Programma per la Tesi di Laurea di Paolo Guagliumi - pguagliumi@libero.it
     Docente relatore: Prof.ssa Paola Giannini - giannini@di.unito.it

     FiltroFile.java - Definizione classe per il filtro di file
    (C) 2002 Paolo Guagliumi - Il programma adotta la licenza GPL allegata

   ****************************************************************************** */


// **** importa i packages utili ****

import java.io.*;

// **** definizione classe per impostare i filtri nella finestra dialog ****

class FiltroFile extends javax.swing.filechooser.FileFilter
{
	private String filtro_estensione = null;
	private String filtro_descrizione = null;

	// costruttore della classe

	public FiltroFile(String estensione, String descrizione)
	{
		filtro_estensione = "." + estensione.toLowerCase();
		filtro_descrizione = descrizione;
	}

	// restituisce la descrizione per il filtro

     public String getDescription()
	{
		return filtro_descrizione;
	}

	// se un determinato file e' accettato da questo filtro

	public boolean accept(File f)
	{
		if (f == null)	return false;
		if (f.isDirectory()) return true;
		return f.getName().toLowerCase().endsWith(filtro_estensione);
	}
}
