/* ******************************************************************************

     XMLStudio - Editor integrato per documenti XML
     Programma per la Tesi di Laurea di Paolo Guagliumi - pguagliumi@libero.it
     Docente relatore: Prof.ssa Paola Giannini - giannini@di.unito.it

     Guida.java - Definizione classe per la Guida in linea del programma
    (C) 2002 Paolo Guagliumi - Il programma adotta la licenza GPL allegata

   ****************************************************************************** */


// **** importa i packages utili ****

import java.io.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;


// **** definizione classe per aprire la guida testuale che ricorda alcune informazioni utili ****

class Guida extends JDialog implements ActionListener
{
	private JButton pulsanteOk; // pulsanteOk per confermare il font scelto

	// **** costruttore della classe Guida ****

	// la JDialog appartiene ad un'altra finestra, il JFrame

	public Guida(JFrame parent) // al costruttore della classe che estende la JDialog passa il JFrame, finestra principale del programma
	{
		super(parent, "Guida testuale", true); // richiama la superclasse per creare la JDialog relativa alla Guida

		final Container contenitoreGuida = this.getContentPane(); // final = inizializzato e non modificabile il contentPane della JDialog
		contenitoreGuida.setLayout(new BorderLayout()); // impostazione del layout del ContentPane della JDialog

		JPanel Pannello = new JPanel(); // definisce un primo pannello
		pulsanteOk = new JButton("Ok");

		pulsanteOk.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				dispose(); // chiude la JDialog con questo metodo di Java
			}
		});

		Pannello.add(pulsanteOk); // aggiunge il pulsanteOk al pannello
		contenitoreGuida.add("South", Pannello); // posiziona il Pannello (con il pulsante Ok) nella parte bassa della JDialog

		JPanel Pannello2 = new JPanel(); // definisce un secondo pannello
		Pannello2.setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5));
		Pannello2.setLayout(new FlowLayout());
		//Pannello2.setLayout(new GridLayout(1,1));

		final JTextArea areaTestoGuida = new JTextArea();

		areaTestoGuida.setFont(new Font("Courier", Font.PLAIN, 12));
		areaTestoGuida.setEditable(false);
		JScrollPane areaTestoScorrimento = new JScrollPane(areaTestoGuida);

		//JViewport port = areaTestoScorrimento.getViewport();
		//port.add(areaTestoGuida);

		areaTestoScorrimento.setMinimumSize(new Dimension(520, 420)); // imposta la dimensione minima dell'area testo
		areaTestoScorrimento.setPreferredSize(new Dimension(520, 420)); // imposta la dimensione predefinita dell'area testo
		Pannello2.add(areaTestoScorrimento);

		contenitoreGuida.add("Center", Pannello2); // posiziona il Pannello2 (con l'areaTestoScorrimento) nella JDialog
		this.setSize(536, 440); // imposta la dimensione della JDialog

		try
		{
			File f = new File("./Risorse/XMLStudio.guida"); // associa all'oggetto f il file selezionato relativo alla guida
        		Reader in = new FileReader(f); // crea l'oggetto in per leggere il file
        		areaTestoGuida.read(in, null); // riporta il contenuto dell'oggetto in su areaTestoGuida
        	}
        	catch(Exception e)
      	{
	     	System.err.println("Errore di apertura del file.");
	     }

		pack(); // causa alla JDialog di essere ridimensionata secondo il layout e la dimensione dei suoi sottocomponenti
		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
		this.setLocation((screenSize.width - getWidth()) / 2, (screenSize.height - getHeight()) / 2); // sposta la JDialog nella posizione centrale
		this.setVisible(true); // la JDialog  visibile
	}


	// **** risponde ad azioni dell'utente ed esegue del codice: in attesa di eventi dai pulsanti ****

	public void actionPerformed(ActionEvent evento) // rileva oggetti ActionEvent
	{
		Object oggettoScelto = evento.getSource(); // grazie ad oggettoScelto individua quale bottone ha causato l'evento

		if (oggettoScelto == pulsanteOk) // se viene premuto il pulsanteOK
		{
			 	dispose(); // chiude la JDialog dopo aver premuto il pulsanteCancella
		}
	}

}