/* ******************************************************************************

     XMLStudio - Editor integrato per documenti XML
     Programma per la Tesi di Laurea di Paolo Guagliumi - pguagliumi@libero.it
     Docente relatore: Prof.ssa Paola Giannini - giannini@di.unito.it

     JOptionPaneEsteso.java - Definizione classe per realizzare JOptionPane
    (C) 2002 Paolo Guagliumi - Il programma adotta la licenza GPL allegata

   ****************************************************************************** */


// **** importa i packages utili ****

import javax.swing.*;
import java.awt.Dimension;


// **** definizione classe per realizzare questo JOptionPane esteso ****

/* questo JOptionPane consente di specificare in testoMessaggio delle stringhe piu'
   lunghe rispetto a  quelle normalmente definibili nei normali JOptionPane */

public class JOptionPaneEsteso extends JDialog
{
	// **** costruttore della classe JOptionPaneEsteso ****

	public JOptionPaneEsteso(JFrame parent, String titolo, String testoMessaggio)
   	{
	   	super(parent, "Impostazione del carattere", true); // richiama la superclasse per creare la JDialog

      	JTextArea tmpAreaTesto = new JTextArea(testoMessaggio); // definisce una JTextArea che conterra' il nostro testo
	     tmpAreaTesto.setLineWrap(true);
     	tmpAreaTesto.setWrapStyleWord(true);
      	tmpAreaTesto.setRows((testoMessaggio.length()/80)+1);
      	tmpAreaTesto.setBackground(getContentPane().getBackground()); // lo sfondo della JTextArea deve essere analogo al JOptionPane

 	 	JOptionPane pane = new JOptionPane(tmpAreaTesto, JOptionPane.WARNING_MESSAGE, JOptionPane.DEFAULT_OPTION );
 	 	Dimension dimensionePane = new Dimension(400, 140); // imposta la dimensione del JOptionPaneEsteso
	 	pane.setPreferredSize(dimensionePane);
      	JDialog dialog = pane.createDialog(getContentPane(), titolo);
      	pack();
      	dialog.setVisible(true);
   }
}