/* ******************************************************************************

     XMLStudio - Editor integrato per documenti XML
     Programma per la Tesi di Laurea di Paolo Guagliumi - pguagliumi@libero.it
     Docente relatore: Prof.ssa Paola Giannini - giannini@di.unito.it

     MyErrorHandler.java - Definizione classe per la gestione degli errori per
      la verifica di validit del documento XML
    (C) 2002 Paolo Guagliumi - Il programma adotta la licenza GPL allegata

   ****************************************************************************** */


// **** importa i packages utili ****

import org.xml.sax.ErrorHandler;
import org.xml.sax.SAXParseException;

// **** questa classe viene utilizzata nel file xmlstudio.java nel metodo azioneValidoXml ****

class MyErrorHandler implements ErrorHandler
{
	boolean valido = true; // per sapere se il file xml corrente e' o meno valido
	XMLStudio oggettoXMLStudioGlobale;
	int numero = 1;

	public MyErrorHandler(XMLStudio oggettoXMLStudio)
	{
		oggettoXMLStudioGlobale = oggettoXMLStudio;
	}

	public void error(SAXParseException exception)
	{
		// System.err.println("ERROR: "+exception);
		JOptionPaneEsteso mostraEccezione = new JOptionPaneEsteso(oggettoXMLStudioGlobale, "Informazione #" + numero, "Il documento non e' valido: " + exception);
		valido = false;
		numero++;
	}

	public void fatalError(SAXParseException exception)
	{
		// System.err.println("FATAL ERROR: "+exception);
	}

	public void warning(SAXParseException exception)
	{
		// System.err.println("WARNING: "+exception);
	}

	public boolean valoreValido()
	{
		return valido;
	}
}