/* ******************************************************************************

     XMLStudio - Editor integrato per documenti XML
     Programma per la Tesi di Laurea di Paolo Guagliumi - pguagliumi@libero.it
     Docente relatore: Prof.ssa Paola Giannini - giannini@di.unito.it

     PopupListener.java - Riceve eventi del mouse
    (C) 2002 Paolo Guagliumi - Il programma adotta la licenza GPL allegata

   ****************************************************************************** */

/* Consente di rilevare quando il mouse e' premuto o rilasciato, cliccato, ecc.
   Ridefizione dei metodi di interesse: mousePressed, mouseReleased */

// **** importa i packages utili ****

import java.awt.event.*;
import javax.swing.JPopupMenu;

// **** definizione classe per ricevere eventi del mouse ****

class PopupListener extends MouseAdapter
{
	JPopupMenu oggettoMenuJPopup = null;

	// **** costruttore della classe PopupListener ****

     public PopupListener(JPopupMenu parametroMenu)
     {
     	oggettoMenuJPopup = parametroMenu;
     }

     // **** invocata quando il pulsante destro del mouse e' premuto su di un componente ****

     public void mousePressed(MouseEvent e)
     {
     	mostraMenuPopup(e);
     }

     // **** invocata quando il pulsante del mouse e' rilasciato su di un componente

     public void mouseReleased(MouseEvent e)
     {
     	mostraMenuPopup(e);
     }

     private void mostraMenuPopup(MouseEvent e)
     {
     	if (e.isPopupTrigger())
          {
          	oggettoMenuJPopup.show(e.getComponent(), e.getX(), e.getY());
          }
     }
}