/* ******************************************************************************

     XMLStudio - Editor integrato per documenti XML
     Programma per la Tesi di Laurea di Paolo Guagliumi - pguagliumi@libero.it
     Docente relatore: Prof.ssa Paola Giannini - giannini@di.unito.it

     StoriaFile.java - Definizione classe per elencare i file aperti di recente
    (C) 2002 Paolo Guagliumi - Il programma adotta la licenza GPL allegata

   ****************************************************************************** */


// **** importa i packages utili ****
import java.io.*;


// **** definizione classe per memorizzare i cammini degli ultimi file aperti ****

public class StoriaFile
{
	//File filestoria = new File("risorse/XMLStudio.his");

	String primo = null, // path relativo all'ultimo file aperto nell'editor
	       secondo = null,
	       terzo = null,
	       quarto = null;

	// **** costruttore della classe StoriaFile ****

	public StoriaFile()
	{
		String linea; // linea del file letta

		try
		{
			BufferedReader in = new BufferedReader(new FileReader("./Risorse/XMLStudio.his"));

			if ((primo = in.readLine()) != null) // carica i path relativi agli ultimi 4 file aperti nell'editor
			{
				if ((secondo = in.readLine()) != null)
				{
					if ((terzo = in.readLine()) != null)
					{
						if ((quarto = in.readLine()) != null);
					}
				}
			}

			/*
			System.out.println("Elenco file recentemente aperti");
			System.out.println("Primo: " + primo);
			System.out.println("Secondo: " + secondo);
			System.out.println("Terzo: " + terzo);
			System.out.println("Quarto: " + quarto);
			System.out.println("--------------------------------");*/
		}
		catch (Exception e)
		{
			System.err.println("Lettura del file XMLStudio.his fallita.");
		}
	}


	// **** metodo per salvare il path degli ultimi 4 file aperti ****

	public void salvaStoriaFile(File ultimofile)
	{
		boolean uguali;
		String temporaneo;

		if ((primo != null) && (primo.equals(ultimofile.getAbsolutePath()))) // il file appena aperto corrisponde il path di primo
		{
			uguali = true; // non e' necessario nessun aggiornamento dei path nel file
		}
		else
			if ((secondo != null) && (secondo.equals(ultimofile.getAbsolutePath()))) // l'ultimo file aperto corrisponde a secondo
			{
				temporaneo = primo; // realizza gli opportuni scambi per spostare secondo in cima della lista
				primo = secondo;
				secondo = temporaneo;
				uguali = false;
			}
			else
				if ((terzo != null) && (terzo.equals(ultimofile.getAbsolutePath()))) // l'ultimo file aperto corrisponde a terzo
				{
					temporaneo = secondo; // realizza scambi per spostare terzo in cima alla lista
					secondo = terzo;
					terzo = temporaneo;
					temporaneo = primo;
					primo = secondo;
					secondo = temporaneo;
					uguali = false;
				}
				else
					if ((quarto != null) && (quarto.equals(ultimofile.getAbsolutePath()))) // l'ultimo file aperto corrisponde a quarto
					{
						temporaneo = terzo; // realizza scambi per spostare quarto in cima alla lista
						terzo = quarto;
						quarto = temporaneo;
						temporaneo = secondo;
						secondo = terzo;
						terzo = temporaneo;
						temporaneo = primo;
						primo = secondo;
						secondo = temporaneo;
						uguali = false;
					}
					else // l'ultimo file aperto non e' presente nell'elenco di file
					{
						//if ((primo != null) && (secondo != null) && (terzo != null) && (quarto != null))
						//{
							quarto = terzo; // realizza scambi per spostare il path di ultimo file in cima alla sequenza
							terzo = secondo;
							secondo = primo;
							primo = ultimofile.getAbsolutePath();
						//}
						uguali = false;
					}

		/*System.out.println("Elenco file recentemente salvati");
		System.out.println("Salvato primo: " + primo);
		System.out.println("Salvato secondo: " + secondo);
		System.out.println("Salvato terzo: " + terzo);
		System.out.println("Salvato quarto: " + quarto);
		System.out.println("--------------------------------");*/

		if (uguali == false) // e' necessario salvare su file le modifiche effettuato
		{
			try
			{
				FileWriter fw = new FileWriter("./Risorse/XMLStudio.his");
		          BufferedWriter bw = new BufferedWriter(fw);
         			PrintWriter out = new PrintWriter(bw);

				if (primo != null)
					out.println(primo); // primo contiene il cammino dell'ultimo file aperto
				if (secondo != null)
					out.println(secondo);
				if (terzo != null)
					out.println(terzo);
				if (quarto != null)
					out.println(quarto);

				out.flush();  // scrive gli ultimi dati rimasti nel buffer
				out.close();
				bw.close();
				fw.close();
			}
			catch (Exception e)
			{
				System.err.println("Scrittura del file XMLStudio.his fallita." + e);
			}
		}
	}
}
